package me.unurled.sacredrealms.sr.components.item;

import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextColor;

public enum Rarity {
  COMMON("<white>Common", "COMMON", 1, NamedTextColor.WHITE),
  UNCOMMON("<green>UnCommon", "UnCOMMON", 2, NamedTextColor.GREEN),
  RARE("<dark_aqua>Rare", "RARE", 3, NamedTextColor.DARK_AQUA),
  EPIC("<dark_purple>Epic", "EPIC", 4, NamedTextColor.DARK_PURPLE),
  LEGENDARY("<gold>Legendary", "LEGENDARY", 5, NamedTextColor.GOLD),
  MYTHIC("<light_purple>Mythic", "MYTHIC", 6, NamedTextColor.LIGHT_PURPLE),
  SPECIAL("<red>Special", "SPECIAL", 7, NamedTextColor.RED),
  UNIQUE("<yellow>Unique", "UNIQUE", 8, NamedTextColor.YELLOW),
  ADMIN(
      "<color:#800000><obf>aa</obf><dark_red>Admin</dark_red><obf>aa</obf></color>", "ADMIN", 100, NamedTextColor.DARK_RED);

  private final String name;
  private final String ID;
  private final Integer weight;
  private final TextColor color;

  Rarity(String name, String ID, Integer weight, TextColor color) {
    this.name = name;
    this.ID = ID;
    this.weight = weight;
    this.color = color;
  }

  public String getName() {
    return name;
  }

  public String getID() {
    return ID;
  }

  public Integer getWeight() {
    return weight;
  }

  public TextColor getColor() {
    return color;
  }
}
