package me.unurled.sacredrealms.sr.components.item;

import java.util.HashMap;
import me.unurled.sacredrealms.sr.managers.Manager;
import org.bukkit.NamespacedKey;

public class ItemManager extends Manager {
    public static final NamespacedKey ID = new NamespacedKey("sr", "ID");

    public HashMap<String, Item> items;

    public ItemManager() {
        super();
        items = new HashMap<>();
    }

    public void addItem(Item item) {
        items.put(item.getID(), item);
    }

    public Item getItem(String id) {
        return items.get(id);
    }

    public void removeItem(String id) {
        items.remove(id);
    }

    public boolean isItem(String id) {
        return items.containsKey(id);
    }
}
